<?php
  //
  // Chapter 10, pg. 275
  //
  require 'Cache/File.inc';
  require 'Project.inc';
  try {
    $name = $_GET[name];
    if(!$name) {
      throw new Exception();
    }
    $project = new Project($name);
  }
  catch (Exception $e) {
    // if I fail, I should go here
    header("Location: /index.php");
    return;
  }
  $cache = new Cache::File(Project::get_cachefile($name));
  $cache->begin();
?>

<html>
<title><?= $project->name ?></title>
<body>
<!-- boilerplate text -->
<table>
  <tr>
    <td>Author:</td><td><?= $project->author ?>
  </tr>
  <tr>
    <td>Summary:</td><td><?= $project->short_description ?>
  </tr>
  <tr>
    <td>Availability:</td><td><a href="<?= $project->file_url ?>">click here</a></td>
  </tr>
  <tr>
    <td><?= $file->long_description ?></td>
  </tr>
</table>
</body>
</html>
<?php
  $cache->end();
?>


<?php
/* vim: set ts=2 sts=2 expandtab ai bs=2 : */
?>
