<?php
//
// Chapter 12, pg. 320
//
require_once "DB.inc";

class Countries {
  private static $nameFromCodeMap = array();

  public static function nameFromCode($code)
  {
    if(!in_array($code, self::$nameFromCodeMap)) {
      $query = "SELECT name FROM countries WHERE countrycode = :1";
      $dbh = new DB_Mysql_Test;
      list ($name) = $dbh->prepare($query)->execute($code)->fetch_row();
      self::$nameFromCodeMap[$code] = $name;
      if($name) {
        self::$codeFromNameMap[$name] = $code;
      }
    }
    return self::$nameFromCodeMap[$code];
  }

  public static function codeFromName($name)
  {
    if(!in_array($name, self::$codeFromNameMap)) {
      $query = "SELECT countrycode FROM countries WHERE name = :1";
      $dbh = new DB_Mysql_Test;
      list ($code) = $dbh->prepare($query)->execute($name)->fetch_row();
      self::$codeFromNameMap[$name] = $code;
      if($code) {
        self::$nameFromCodeMap[$code] = $name;
      }
    }
    return self::$codeFromNameMap[$name];
  }
}

print Countries::nameFromCode('us')."\n";
print Countries::codeFromName('Canada')."\n";

/* vim: set ts=2 sts=2 expandtab ai bs=2 : */
?>
