<?php
  //
  // Chapter 13, pg. 341-343
  //
  require_once 'Cookie.inc';
  require_once 'Exception.inc';
  class SignOnException extends Exception {
  }

  function check_auth() {
    try {
      $cookie = new Cookie();
      $cookie->validate();
    }
    catch(AuthException $e) {
      try {
        $client = new SingleSignOn();
        $client->process_auth_response($_GET['response']);
        $cookie->userid = $client->userid;
        $cookie->set();
      }
      catch(SignOnExcpetion $e) {
        $client->generate_auth_request();
        exit;
      }
    }
  }

  class SingleSignOn {
    protected $cypher     = 'blowfish';
    protected $mode       = 'cfb';
    protected $key = 'choose a better key';
    protected $td;


    protected $glue = '|';
    protected $clock_skew = 60;
    protected $myversion = 1;

    protected $client;
    protected $server;
    protected $userid;
    public $originating_uri;

    public function __construct() {
      $this->td = mcrypt_module_open ($cypher, '', $mode, '');
    }

    protected function _encrypt($plaintext) {
      $iv = mcrypt_create_iv (mcrypt_enc_get_iv_size ($td), MCRYPT_RAND);
      mcrypt_generic_init ($this->td, $this->key, $iv);
      $crypttext = mcrypt_generic ($this->td, $plaintext);
      mcrypt_generic_deinit ($this->td);
      return $iv.$crypttext;
    }
    protected function _decrypt($crypttext) {
      $ivsize = mcrypt_get_iv_size($this->td);
      $iv = substr($crypttext, 0, $ivsize);
      $crypttext = substr($crypttext, $ivsize);
      mcrypt_generic_init ($this->td, $this->key, $iv);
      $plaintext = mdecrypt_generic ($this->td, $crypttext);
      mcrypt_generic_deinit ($this->td);
      return $plaintext;
    }

    public function generate_auth_request() {
      $parts = array($this->myversion, time(), $this->client, $this->originating_uri);
      $plaintext = implode($this->glue, $parts);
      $request = $this->_encrypt($plaintext);
      header("Location: $client->server?request=$request");
    } 
    public function process_auth_request($crypttext) {
      $plaintext = $this->_decrypt($crypttext);
      list($version, $time, $this->client, $this->originating_uri) = 
        explode($this->glue, $plaintext);
      if( $version != $this->myversion) {
        throw new SignonException("version mismatch");
      }
      if(abs(time() - $time) > $this->clock_skew) {
        throw new SignonException("request token is outdated");
      }
    }
    public function generate_auth_response() {
      $parts = array($this->myversion, time(), $this->userid);
      $plaintext = implode($this->glue, $parts);
      $request = $this->_encrypt($plaintext);
      header("Location: $this->client$this->originating_uri?response=$request");
    } 
    public function process_auth_response($crypttext) {
      $plaintext = $this->_decrypt($crypttext);
      list ($version, $time, $this->userid) = explode($this->glue, $plaintext);
      if( $version != $this->myversion) {
        throw new SignonException("version mismatch");
      }
      if(abs(time() - $time) > $this->clock_skew) {
        throw new SignonException("response token is outdated");
      }
      return $this->userid;
    }
  }

  function authenticate($name, $password, $client) {
    $dbh = new DB::Mysql::Test();
    $cur = $dbh->execute("
      SELECT
        userid
      FROM
        ss_users
      WHERE
        name = '$name'
      AND password = '$password'
      AND client = '$client'");
    $row = $cur->fetch_assoc();
    if($row) {
      $userid = $row['userid'];
    }
    else {
      throw new SignonExcpetion("user is not authorized");
    }
    return $userid;
  }

  function authenticateFromCookie($userid, $server) {
    $dbh = new DB::Mysql::Test();
    $cur = $dbh->execute("
      SELECT
        userid
      FROM
        ss_users
      WHERE
        userid = '$userid'
      AND server = '$server'");
    $row = $cur->fetch_assoc();
    if(!$row) {
      throw new SignonExcpetion("user is not authorized");
    }
  }

/* vim: set ts=2 sts=2 ai bs=2 expandtab: */
?>
