<?php
//
// Chapter 19, pg. 470
//
require 'RusageBench.inc';

function interpolated($name, $iter) 
{
  for($i=0;$i<$iter; $i++) {
    $string = "Hello $name and have a very nice day!\n";
  }
}

function concatenated($name, $iter) 
{
  for($i=0;$i<$iter; $i++) {
    $string = "Hello ".$name." and have a very nice day!\n";
  }
}

$iterations = 1000000;
foreach(array('interpolated', 'concatenated') as $func) {
  $bm = new RusageBench;
  $bm->run(1, $func, 'george', $iterations);
  $result = $bm->get();
  printf("$func\tUser Time + System Time: %0.6f\n",
	($result['mean']['ru_utime'] + $result['mean']['ru_stime'])/$iterations);
}
?>
