<?php
//
// Chapter 2, pg. 62
//
class Typed {
  private $props = array();
  static $types = array (
    "counter" => "is_integer",
    "name" => "is_string"
  );
  public function __get($name) {
    if(array_key_exists($name, $this->props)) {
      return $this->props[$name];
    }
  }
  public function __set($name,$value) {
    if(array_key_exists($name, self::$types)) {
      if(call_user_func(self::$types[$name],$value)) {
        $this->props[$name] = $value;
      }
      else {
        print "Type assignment error\n";
        debug_print_backtrace();
      }
    }
  }
}

$obj = new Typed;
$obj->name = array("George");

?>
