#!/usr/bin/env php
<?php
//
// Chapter 5, pg. 132-133
//
define('PROCESS_COUNT', '5');
$children = array();
for($i = 0; $i < PROCESS_COUNT; $i++) {
  if(($pid = pcntl_fork()) == 0) {
    exit(child_main());
  }
  else {
    $children[] = $pid;
  }  
}

foreach($children as $pid) {
  $pid = pcntl_wait($status);
  if(pcntl_wifexited($status)) {
    $code = $status >>= 8;
    print "pid $pid returned exit code: $code\n";
  }
  else {
    print "$pid was unnaturally terminated\n";
  }
}

function child_main() 
{
  $my_pid = getmypid();
  print "Starting child pid $my_pid\n";
  sleep(15);
  return  1;
}
?>
